Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2323 by niro, Fri Jan 3 13:19:11 2014 UTC revision 2402 by niro, Tue Jan 7 13:17:47 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  #images: (get ${CDIMAGENAME})  # ignore the environment
11  source /mnt/cdrom/system/images.conf  LC_ALL=C
12    # include dir
13    INSTALLER_LIBDIR="%LIBDIR%"
14    
15  #Includes  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16  source /usr/lib/installer/functions/findhdd.sh > /dev/null  # -> now in images.conf
17  ### bugfix ###############################  CURRENTLINE=0
 cdromdev="$(echo ${cdromdev} | sed 's/ //')"  
 ########################################  
18    
19  ### System/Config Version  die()
20  VERSION="%VERSIONTAG%"  {
21  TITLE="Installer - ${VERSION}"   echo "Error: $@"
22     exit 1
23    }
24    
25  CDPATH="/mnt/cdrom"  # load common includes
26  INSTALLPATH="/mnt/magellan"  for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31    do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41    # -> now in images.conf
42    CDIMAGENAME=""
43    TOTALLINES=""
44  CURRENTLINE=0  CURRENTLINE=0
45  #TOTALLINES=11072 # -> now in images.conf  if [ -e /mnt/cdrom/system/images.conf ]
46    then
47     source /mnt/cdrom/system/images.conf
48     # check if all required variables are set
49     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
50     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
51    else
52     die "/mnt/cdrom/system/images.conf not found"
53    fi
54    
55    # includes
56    source ${INSTALLER_LIBDIR}/functions/hwdetection.sh
57    
58    ### System/Config Version
59    VERSION="%VERSIONTAG%"
60    TITLE="${DEFAULT_TITLE} - ${VERSION}"
61    
62    CDROOT="${DEFAULT_CDROOT}"
63    INSTALLROOT="${DEFAULT_INSTALLROOT}"
64    
65  # standard kernel opts  # standard kernel opts
66  KERNELOPTS="quiet video=1024x768"  KERNELOPTS="quiet video=1024x768"
# Line 42  SPECIALDEVICE="" Line 77  SPECIALDEVICE=""
77  FORMFACTOR="desktop"  FORMFACTOR="desktop"
78    
79  # target filesystem  # target filesystem
80  FORMAT_FILESYSTEM="ext4"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
81    
82  #################################################  #################################################
83  #  DIALOG BOXEN #  #  DIALOG BOXEN #
84  #################################################  #################################################
85    
86  die()  dialog_die()
87  {  {
88   ERROR=$1   ERROR="$1"
89   RETVAL=$?   RETVAL="$?"
90   dialog_install_failure   dialog_install_failure
91   exit 1   exit 1
92  }  }
93    
94  dialog_warning()  dialog_warning()
95  {  {
96   dialog \   local retval
97   --backtitle "${TITLE}" \  
98   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
99   --defaultno \   retval=$?
100   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
101   then   then
102   clear   clear
103   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
104   exit 1   exit 1
105   fi   fi
106  }  }
107    
108  dialog_setup_hdd_info()  dialog_setup_hdd_info()
109  {  {
  local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
110   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="$(echo $HDD | sed 's/\/dev\///')"
111    
112   dialog \   dialog \
# Line 133  dialog_setup_system_menu() Line 148  dialog_setup_system_menu()
148   "" "" \   "" "" \
149   "" "\Z1Experten Modi:\Zn" \   "" "\Z1Experten Modi:\Zn" \
150   "2" "Normale IDE-Disk (Manuell)" \   "2" "Normale IDE-Disk (Manuell)" \
  "3" "Flash-Speicher (Manuell)")  
151   RES=$?   RES=$?
152   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
153   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
154   then   then
155   case "${i}" in   case "${i}" in
156   "1") run_install_auto ;;   "1") run_install_auto ;;
157           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
158   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
159   esac   esac
160   fi   fi
# Line 152  dialog_hardware_detection() Line 165  dialog_hardware_detection()
165   local i   local i
166   local hwtmp   local hwtmp
167    
168   if [ -x $(which mktemp &> /dev/null) ]   if [ -x $(type -P mktemp) ]
169   then   then
170   hwtmp="$(mktemp)"   hwtmp="$(mktemp)"
171   else   else
172   hwtmp="/tmp/hwtmp.sh"   hwtmp="/tmp/hwtmp.sh"
173   fi   fi
174    
175   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
176    
177   echo "dialog \\"  > ${hwtmp}   echo "dialog \\"  > ${hwtmp}
178   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
# Line 169  dialog_hardware_detection() Line 182  dialog_hardware_detection()
182   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
183   echo " Festplatten:\n \\" >> ${hwtmp}   echo " Festplatten:\n \\" >> ${hwtmp}
184    
185   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
186   then   then
187   for i in ${scsidisks}   for i in ${ALL_DISKS}
188   do   do
189   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
190   done   done
191   fi   fi
192    
193   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
194   then   then
195   for i in ${idedisks}   echo " \n \\" >> ${hwtmp}
196     echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
197     for i in ${ALL_CDROMS}
198   do   do
199   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
200   done   done
201   fi   fi
202    
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
  fi  
   
203   # other devices   # other devices
204   run_hardware_detection   run_hardware_detection
205   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
# Line 262  dialog_setup_hdd_partitions_manuell() Line 262  dialog_setup_hdd_partitions_manuell()
262   fi   fi
263  }  }
264    
265  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
266  {  {
267   local i   local i
268    
# Line 294  dialog_setup_hdd_partitions_manuell_flas Line 294  dialog_setup_hdd_partitions_manuell_flas
294   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
295   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
296   then   then
297   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
298   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
299     setup_hdd_partitions_auto
300   fi   fi
301   fi   fi
302  }  }
303    
304  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
305  {  {
306   local i   local bootdev
307    
308   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
309     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
310     # remove the boot device from ALL_DISKS if it was an usbstick
311     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
312   then   then
313   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
314   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
315   fi   fi
316     export ALL_CDROMS="$(get_hwinfo cdrom)"
317  }  }
318    
319  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 427  dialog_main() Line 404  dialog_main()
404   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
405   then   then
406   case ${METHOD} in   case ${METHOD} in
407           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
408   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
409   "3") install_do_reboot ;;   "3") install_do_reboot ;;
410   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 501  hdd_size_below_256mb() Line 478  hdd_size_below_256mb()
478   local hdd="$1"   local hdd="$1"
479   local size   local size
480   local retval   local retval
481   [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"   [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
482    
483   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
484   if [[ ${size} -le 257000000 ]]   if [[ ${size} -le 257000000 ]]
# Line 530  setup_hdd_partitions_auto() Line 507  setup_hdd_partitions_auto()
507   fi   fi
508    
509   ## delete disk   ## delete disk
510   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
511    
512   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
513   then   then
# Line 578  EOF Line 555  EOF
555    
556  setup_hdd_partitions_manuell()  setup_hdd_partitions_manuell()
557  {  {
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
 {  
558   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
559    
560   ## hdds partitionieren manuell   ## hdds partitionieren manuell
561   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
562  }  }
563    
564  setup_hdd_format()  setup_hdd_format()
565  {  {
566   mkswap ${SWAPHDD} || die   mke2fs -j -q ${ROOTHDD} || dialog_die
  mke2fs -j -q ${BOOTHDD} || die  
  mke2fs -j -q ${ROOTHDD} || die  
 }  
   
 setup_hdd_format_flash()  
 {  
  mke2fs -j -q ${ROOTHDD} || die  
567  }  }
568    
569  install_mount_rootfs()  install_mount_rootfs()
570  {  {
571   swapon ${SWAPHDD} || die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
572   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
573   install -d ${INSTALLPATH}/boot || die   cd ${INSTALLROOT} || dialog_die
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
574  }  }
575    
576  install_system_image()  install_system_image()
577  {  {
578   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
579  }  }
580    
581  install_bootsector_chroot()  install_bootsector_chroot()
582  {  {
583   local my_roothdd   local my_roothdd
584   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
585   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
586    
587   # check for grub2   # check for grub2
588   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
589   then   then
590   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
591   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
592   then   then
593   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
594   fi   fi
595    
596   # set kernelopts   # set kernelopts
597   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
598   then   then
599   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
600   else   else
601   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
602   fi   fi
603   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
604   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
605   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
606   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
607    
608   # grub-legacy   # grub-legacy
609   else   else
610   ### grubconf schreiben   ### grubconf schreiben
611   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
612    
613   #for alx only   #for alx only
614   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
615   then   then
616   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
617   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
618   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
619   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
620   fi   fi
# Line 680  install_bootsector_chroot() Line 631  install_bootsector_chroot()
631   my_roothdd="${ROOTHDD}"   my_roothdd="${ROOTHDD}"
632   fi   fi
633    
634   : > ${grubconf} || die   : > ${grubconf} || dialog_die
635   echo "default 0" >> ${grubconf} || die   echo "default 0" >> ${grubconf} || dialog_die
636   echo "timeout 3" >> ${grubconf} || die   echo "timeout 3" >> ${grubconf} || dialog_die
637   # using current root password   # using current root password
638   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
639    
640   echo  >> ${grubconf} || die   echo  >> ${grubconf} || dialog_die
641   echo "# normal boot" >> ${grubconf} || die   echo "# normal boot" >> ${grubconf} || dialog_die
642   echo "title ${KRNVER}" >> ${grubconf} || die   echo "title ${KRNVER}" >> ${grubconf} || dialog_die
643   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
644   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
645   if is_initrd_supported   if is_initrd_supported
646   then   then
647   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
648   fi   fi
649    
650   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
651   echo "# admin boot" >> ${grubconf} || die   echo "# admin boot" >> ${grubconf} || dialog_die
652   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
653   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
654   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
655   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
656   if is_initrd_supported   if is_initrd_supported
657   then   then
658   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
659   fi   fi
660    
661   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
662   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
663   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
664   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
665   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
666   if is_initrd_supported   if is_initrd_supported
667   then   then
668   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
669   fi   fi
670    
671   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
672   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
673  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
674  root (hd0,0)  root (hd0,0)
675  setup (hd0)  setup (hd0)
# Line 728  exit 0 Line 679  exit 0
679  CHROOTEOF  CHROOTEOF
680   fi   fi
681    
682   ## enters chroot   ## enter chroot
683   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
684   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
685   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
686   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
687   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
688   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
689   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
690   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
691  }  }
692    
693  is_initrd_supported()  is_initrd_supported()
694  {  {
695   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
696   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
697   return 1   return 1
698  }  }
699    
# Line 773  install_initrd_chroot() Line 724  install_initrd_chroot()
724   fi   fi
725    
726   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
727   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
728   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
729    
730   # install an appropriate viafb.conf   # install an appropriate viafb.conf
731   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
732    
733   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
734   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
735    
736   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
737  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
738  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
739  exit 0  exit 0
740  CHROOTEOF  CHROOTEOF
741    
742   ## enters chroot   ## enters chroot
743   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
744   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
745   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
746   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
747   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
748   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
749   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
750   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
751  }  }
752    
753  is_uuid_supported()  is_uuid_supported()
754  {  {
755   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
756   then   then
757   # only detect uuids if supported   # only detect uuids if supported
758   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 820  get_uuid() Line 771  get_uuid()
771   local TYPE   local TYPE
772    
773   local dev="$1"   local dev="$1"
774   [[ -z ${dev} ]] && die "no dev given"   [[ -z ${dev} ]] && dialog_die "no dev given"
775    
776   # check if given device is already an UUID   # check if given device is already an UUID
777   if [[ ${dev/UUID=/}x != ${dev}x ]]   if [[ ${dev/UUID=/}x != ${dev}x ]]
# Line 837  install_system_settings() Line 788  install_system_settings()
788   # schreibe fstab   # schreibe fstab
789   if is_uuid_supported   if is_uuid_supported
790   then   then
791   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
792   else   else
793   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
794   fi   fi
795   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
796   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
797   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
798   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
799    
800   # install network config skeleton   # install network config skeleton
801   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
802    
803   # intel framebufer quirk   # intel framebufer quirk
804   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 859  install_system_settings() Line 808  install_system_settings()
808   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
809   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
810   then   then
811   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
812   fi   fi
813   fi   fi
814   fi   fi
815  }  }
816    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
817  install_umount_rootfs()  install_umount_rootfs()
818  {  {
819   cd /   cd /
820   umount ${INSTALLPATH}/boot || die   umount ${INSTALLROOT}/boot || dialog_die
821   umount ${INSTALLPATH} || die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
822  }  }
823    
824  install_do_reboot()  install_do_reboot()
# Line 923  run_install_normal() Line 852  run_install_normal()
852   dialog_install_successful   dialog_install_successful
853  }  }
854    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
855  run_install_auto()  run_install_auto()
856  {  {
857   dialog_hardware_detection   dialog_hardware_detection
858    
859   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
860   dialog_setup_hdd_format   dialog_setup_hdd_format
861   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
862   install_mount_rootfs_flash   install_mount_rootfs
863   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
864    
865   dialog_install_settings   dialog_install_settings
866   sleep 1   sleep 1
867   install_system_settings_flash   install_system_settings
868   install_initrd_chroot   install_initrd_chroot
869    
870   dialog_install_bootsector   dialog_install_bootsector
871   install_bootsector_chroot   install_bootsector_chroot
872    
873   install_umount_rootfs_flash   install_umount_rootfs
874   dialog_install_successful   dialog_install_successful
875  }  }
876    

Legend:
Removed from v.2323  
changed lines
  Added in v.2402